/*
 Languages for Scientific Computing
 ----
*/
// to compile:
// gcc test10b.c -o test.x -Wall

// more on pointers and memory allocation



#include <stdlib.h>   // (almost) always necessary
#include <stdio.h>    // (almost) always necessary


double* createMatrix( int size );
   int  createMatrix2( double **matrix, int size ); 
   int  myPrint( double* array, char *name, int n );
   int  changeVal( double *variable, double value ){
      printf("changeVal!\n"); *variable = value; return 0; }



int main(int argc, char *argv[] )
{
   int n;
   double array[] = {4.4, 3.3, 2.2, 1.1};
   
   if(argc == 1){
      printf( "argument needed: pass me an integer\n");
      return( -1 );
   }
   else n = atoi(argv[1]);


   double v; 
   printf( "v before: %lf\n", v );
   changeVal( &v, 1.0*n );
   printf( "v  after: %lf\n", v );
   printf( "\n\n");



   double val;
   double * w;
   *w = -15.0;                      // no!!!!
   printf( "w before: %lf\n", *w );
   changeVal( w, -1.0*n );
   printf( "w  after: %lf\n", *w );
   printf( "\n\n");



   w = &array[2];  // initialization!!!
   *w = 5.0;       // now it's ok
   printf( "*w - before:\t %lf\n", *w );
   changeVal( w, 10. * n );
   printf( "*w - after: \t %lf\n", *w  );
   myPrint( array, "A", 4 );
   myPrint( array, "A", 10 );
   printf( "\n\n\n");



   double*w2,k = 7.77;
   w2 = &k;  // init
   printf( "*w2 - before:\t %g\n", *w2 );
   changeVal( w2, 100. * n );
   printf( "*w2 - after:\t %g\t\tk - after:\t %g\n", *w2, k );
   printf( "\n\n\n");

   

   w2 = (double *) malloc( sizeof( double ) ); // yet another way to init a pointer
   printf( "*w2 malloc - before:\t %.15lf\n", *w2 );
   *w2 = 1234.5678;
   printf( "*w2 malloc - after:\t %.15lf\n", *w2  );
   printf( "\n\n\n");
   free( w2 );
  

   int i;
   double * matrix;      // matrix will be a matrix
   matrix = createMatrix( n );
   myPrint( matrix, "uninitializedMatrix", n );
   for( i=n; i>0; i-- ) matrix[i-1]=100-i;
   myPrint( matrix, "initializedMatrix", n );
   free( matrix );
   printf( "\n\n\n");

   
   
   double *matrix2;  
   createMatrix2( &matrix2, n );
   myPrint( matrix2, "outside", n );
   free( matrix2 );


   
   return( 0 );
}


double* createMatrix( int size )
{
   return( (double *) malloc( size * sizeof( double ) ) );
}



int createMatrix2( double **matrix, int n )
{
   int i;
   double *M;
   M = (double *) malloc( n * sizeof(double) );
   if(M == NULL){
      fprintf(stderr, "Not enough memory to allocate %ld bytes.", 
	      n * sizeof(double) );
      return( 1 );
   }

   // *matrix = (double *) malloc( n * sizeof(double) );

   for( i=n; i>0; i-- ) M[i-1]=-100-i;
   myPrint( M, "inside", n );

   *matrix = M; 
   
   return( 0 );
}




int myPrint( double* array, char *name, int n )
{
   int i;

   printf(" %s = [", name );
   for( i=0; i<n; i++ ) printf("%lf ", array[i] );
   printf("];\n");

   return( 0 );
}

